## shadowsocks-libev 3.3.5+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

set(PROJECT_NAME shadowsocks-libev)
set(RELEASE_DATE 2020-09-15)
set(PROJECT_VERSION "3.3.5")
set(PROJECT_DESC "a lightweight secured socks5 proxy")
set(PROJECT_URL "https://shadowsocks.org")
set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
project(${PROJECT_NAME} VERSION ${PROJECT_VERSION})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")

#set(PROJECT_BINARY_DIR ${PROJECT_SOURCE_DIR}/out)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
set(RUNTIME_SHARED_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/shared/bin)

set(CMAKE_MACOSX_RPATH TRUE)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif ()
# Detect linux
if (UNIX AND NOT APPLE)
    set(LINUX TRUE)
endif ()

message(STATUS "Running cmake version ${CMAKE_VERSION}")

option(WITH_STATIC "build with static libraries." ON)
option(WITH_EMBEDDED_SRC "build with embedded libcork, libipset, and libbloom source." ON)

# Will set GIT_EXECUTABLE and GIT_FOUND
# find_package(Git)

# When choose to not use embedded libcork, libipset and libbloom, use libs shipped by system
if (NOT WITH_EMBEDDED_SRC)
    set(USE_SYSTEM_SHARED_LIB TRUE)
endif ()

# Run platform tests
include(${PROJECT_SOURCE_DIR}/cmake/configure.cmake)
configure_file(${PROJECT_SOURCE_DIR}/cmake/config.h.cmake ${PROJECT_BINARY_DIR}/src/config.h)
add_definitions(-I${PROJECT_BINARY_DIR}/src)
add_definitions(-DHAVE_CONFIG_H)

# pkg-config
configure_file(
        ${PROJECT_SOURCE_DIR}/cmake/shadowsocks-libev.pc.cmake
        ${PROJECT_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
        @ONLY
)
install(FILES
        ${PROJECT_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
        DESTINATION lib/pkgconfig
        )

if (WITH_EMBEDDED_SRC)
# We need libcork,libipset headers
include_directories(libcork/include)
include_directories(libipset/include)
include_directories(libbloom/murmur2)
include_directories(libbloom)

set(LIBCORK_SOURCE
        libcork/src/libcork/cli/commands.c
        libcork/src/libcork/core/allocator.c
        libcork/src/libcork/core/error.c
        libcork/src/libcork/core/gc.c
        libcork/src/libcork/core/hash.c
        libcork/src/libcork/core/ip-address.c
        libcork/src/libcork/core/mempool.c
        libcork/src/libcork/core/timestamp.c
        libcork/src/libcork/core/u128.c
        libcork/src/libcork/core/version.c
        libcork/src/libcork/ds/array.c
        libcork/src/libcork/ds/bitset.c
        libcork/src/libcork/ds/buffer.c
        libcork/src/libcork/ds/dllist.c
        libcork/src/libcork/ds/file-stream.c
        libcork/src/libcork/ds/hash-table.c
        libcork/src/libcork/ds/managed-buffer.c
        libcork/src/libcork/ds/ring-buffer.c
        libcork/src/libcork/ds/slice.c
        libcork/src/libcork/posix/directory-walker.c
        libcork/src/libcork/posix/env.c
        libcork/src/libcork/posix/exec.c
        libcork/src/libcork/posix/files.c
        libcork/src/libcork/posix/process.c
        libcork/src/libcork/pthreads/thread.c
        )
if (NOT MINGW)
set(LIBCORK_SOURCE ${LIBCORK_SOURCE} libcork/src/libcork/posix/subprocess.c)
else ()
set(LIBCORK_SOURCE ${LIBCORK_SOURCE} libcork/src/libcork/posix/mingw.c)
endif ()

if (WITH_STATIC)
add_library(cork STATIC ${LIBCORK_SOURCE})
target_compile_definitions(cork PUBLIC -DCORK_API=CORK_LOCAL)
endif ()

add_library(cork-shared SHARED ${LIBCORK_SOURCE})
target_compile_definitions(cork-shared PUBLIC -DCORK_API=CORK_EXPORT)
set_target_properties(cork-shared PROPERTIES OUTPUT_NAME cork)
if (MINGW)
target_link_libraries(cork-shared ws2_32)
endif ()

set(LIBIPSET_SOURCE
        libipset/src/libipset/general.c
        libipset/src/libipset/bdd/assignments.c
        libipset/src/libipset/bdd/basics.c
        libipset/src/libipset/bdd/bdd-iterator.c
        libipset/src/libipset/bdd/expanded.c
        libipset/src/libipset/bdd/reachable.c
        libipset/src/libipset/bdd/read.c
        libipset/src/libipset/bdd/write.c
        libipset/src/libipset/map/allocation.c
        libipset/src/libipset/map/inspection.c
        libipset/src/libipset/map/ipv4_map.c
        libipset/src/libipset/map/ipv6_map.c
        libipset/src/libipset/map/storage.c
        libipset/src/libipset/set/allocation.c
        libipset/src/libipset/set/inspection.c
        libipset/src/libipset/set/ipv4_set.c
        libipset/src/libipset/set/ipv6_set.c
        libipset/src/libipset/set/iterator.c
        libipset/src/libipset/set/storage.c
        )

if (WITH_STATIC)
add_library(ipset STATIC ${LIBIPSET_SOURCE})
endif ()

add_library(ipset-shared SHARED ${LIBIPSET_SOURCE})
set_target_properties(ipset-shared PROPERTIES OUTPUT_NAME ipset)

set(LIBBLOOM_SOURCE
        libbloom/bloom.c
        libbloom/murmur2/MurmurHash2.c
        )

if (WITH_STATIC)
add_library(bloom STATIC ${LIBBLOOM_SOURCE})
target_link_libraries(ipset cork bloom)
endif ()

add_library(bloom-shared SHARED ${LIBBLOOM_SOURCE})
target_link_libraries(ipset-shared cork-shared bloom-shared)
set_target_properties(bloom-shared PROPERTIES OUTPUT_NAME bloom)
endif ()

add_subdirectory(src)
add_subdirectory(doc)

=== doc/CMakeLists.txt ===
find_program(XMLTO_EXECUTABLE NAMES xmlto)
find_program(ASCIIDOC_EXECUTABLE NAMES asciidoc asciidoc.py)

# Opt-in doc build option
if (NOT XMLTO_EXECUTABLE OR NOT ASCIIDOC_EXECUTABLE)
    option(WITH_DOC_MAN "Build manpage doc" OFF)
else ()
    option(WITH_DOC_MAN "Build manpage doc" ON)
endif ()

if (NOT ASCIIDOC_EXECUTABLE)
    option(WITH_DOC_HTML "Build html doc" OFF)
else ()
    option(WITH_DOC_HTML "Build html doc" ON)
endif ()

# NOTE For brew user, we have to setup this env var. see `brew info asciidoc'
set(XMLTO_ENV)
set(XMLTO_CATALOG_DIR_MACOS /usr/local/etc/xml/catalog)
if (EXISTS ${XMLTO_CATALOG_DIR_MACOS})
    set(XMLTO_ENV XML_CATALOG_FILES=${XMLTO_CATALOG_DIR_MACOS})
    message(STATUS "Detect xmlto catalog dir ${XMLTO_CATALOG_DIR_MACOS}")
endif ()

set(CMAKE_MANPAGE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/man)
set(CMAKE_HTML_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/html)

set(DOC_DIR ${PROJECT_SOURCE_DIR}/doc)
set(XMLTO_OPTS -m ${DOC_DIR}/manpage-normal.xsl -m ${DOC_DIR}/manpage-bold-literal.xsl man)
set(ASCIIDOC_XML_OPTS -b docbook -d manpage -f ${DOC_DIR}/asciidoc.conf -aversion=${PROJECT_VERSION})
set(ASCIIDOC_HTML_OPTS -b html4 -d article -f ${DOC_DIR}/asciidoc.conf -aversion=${PROJECT_VERSION})


set(MAN_NAMES ss-local.1 ss-manager.1 ss-nat.1 ss-redir.1 ss-server.1 ss-tunnel.1 shadowsocks-libev.8)
set(MAN_FILES)
set(HTML_FILES)

foreach (manfile IN LISTS MAN_NAMES)
    string(REGEX REPLACE \\.. .xml xmlfile ${manfile})
    string(REGEX REPLACE \\.. .asciidoc docfile ${manfile})
    string(REGEX REPLACE \\.. .html htmlfile ${manfile})

    set(manfile ${CMAKE_MANPAGE_OUTPUT_DIRECTORY}/${manfile})
    set(htmlfile ${CMAKE_HTML_OUTPUT_DIRECTORY}/${htmlfile})
    set(docfile ${DOC_DIR}/${docfile})

    add_custom_command(OUTPUT ${manfile}
            COMMAND ${ASCIIDOC_EXECUTABLE} ${ASCIIDOC_XML_OPTS} -o ${xmlfile} ${docfile}
            COMMAND ${CMAKE_COMMAND} -E env ${XMLTO_ENV} ${XMLTO_EXECUTABLE} ${XMLTO_OPTS} ${xmlfile}
            # After we built the manpage, the xmlfile is nolongger needed
            COMMAND ${CMAKE_COMMAND} -E remove ${xmlfile}
            DEPENDS ${docfile}
            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/man
            COMMENT "Building manpage ${manfile}"
            VERBATIM)
    list(APPEND MAN_FILES ${manfile})

    add_custom_command(OUTPUT ${htmlfile}
            COMMAND ${ASCIIDOC_EXECUTABLE} ${ASCIIDOC_HTML_OPTS} -o ${htmlfile} ${docfile}
            DEPENDS ${docfile}
            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/html
            COMMENT "Building htmlfile ${htmlfile}"
            VERBATIM)
    list(APPEND HTML_FILES ${htmlfile})
endforeach ()

add_custom_target(doc-man ALL DEPENDS ${MAN_FILES})
add_custom_target(doc-html ALL DEPENDS ${HTML_FILES})


if (NOT WITH_DOC_MAN)
    set_target_properties(doc-man PROPERTIES EXCLUDE_FROM_ALL TRUE)
else ()
    install(DIRECTORY ${PROJECT_BINARY_DIR}/man/
            DESTINATION share/man/man1
            FILES_MATCHING PATTERN "*.1"
            )
    install(DIRECTORY ${PROJECT_BINARY_DIR}/man/
            DESTINATION share/man/man8
            FILES_MATCHING PATTERN "*.8"
            )
endif ()
if (NOT WITH_DOC_HTML)
    set_target_properties(doc-html PROPERTIES EXCLUDE_FROM_ALL TRUE)
else ()
    install(DIRECTORY ${PROJECT_BINARY_DIR}/html/
            DESTINATION share/doc/${PROJECT_NAME})
endif ()

# This is required for custom command
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/man)
file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/html)

=== src/CMakeLists.txt ===
# redir need linux/* stuff
if (LINUX)
    option(WITH_SS_REDIR "Build ss-redir" ON)
    option(WITH_SS_MANAGER "Build ss-manager" ON)
else ()
    option(WITH_SS_REDIR "Build ss-redir" OFF)
    option(WITH_SS_MANAGER "Build ss-manager" OFF)
endif ()


set(SS_ACL_SOURCE
        acl.c
        rule.c
        )

set(SS_CRYPTO_SOURCE
        crypto.c
        aead.c
        stream.c
        base64.c
        )

set(SS_PLUGIN_SOURCE
        plugin.c
        )

set(SS_SHARED_SOURCES
        ppbloom.c
        utils.c
        jconf.c
        json.c
        netutils.c
        )
if (MINGW)
set(SS_SHARED_SOURCES ${SS_SHARED_SOURCES} winsock.c)
endif ()

set(LIBSHADOWSOCKS_LIBEV_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        local.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_ACL_SOURCE}
        )

set(SS_LOCAL_SOURCE
        ${LIBSHADOWSOCKS_LIBEV_SOURCE}

        )

set(SS_TUNNEL_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        tunnel.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        )

set(SS_SERVER_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        resolv.c
        server.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_ACL_SOURCE}
        )

set(SS_MANAGER_SOURCE
        ${SS_SHARED_SOURCES}
        manager.c
        )

set(SS_REDIR_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        redir.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        )

if (CMAKE_SYSTEM_NAME STREQUAL Darwin)
find_path(LIBSODIUM_INCLUDE_DIR sodium.h
        PATHS
        $ENV{LIBSODIUM_INCLUDE_DIR}
        $ENV{LIBSODIUM_DIR}/include
        /usr/local/libsodium/include
        /opt/libsodium/include
        /usr/local/include
)
include_directories(${LIBSODIUM_INCLUDE_DIR})
endif ()

if (WITH_STATIC)
find_library(LIBSODIUM libsodium.a)
find_library(LIBMBEDTLS libmbedtls.a)
find_library(LIBMBEDCRYPTO libmbedcrypto.a)
find_library(LIBEV libev.a)
find_library(LIBUDNS libcares.a)
find_library(LIBPCRE libpcre.a)

# Dependencies we need for static and shared
list(APPEND DEPS
        m
        bloom
        ${LIBEV}
        ${LIBUDNS}
        ${LIBPCRE}
        ${LIBSODIUM}
        ${LIBMBEDTLS}
        ${LIBMBEDCRYPTO}
        )

if (MINGW)
list(APPEND DEPS ws2_32)
add_compile_definitions(CARES_STATICLIB PCRE_STATIC)
endif ()
endif ()

find_library(LIBSODIUM_SHARED sodium)
find_library(LIBMBEDTLS_SHARED mbedtls)
find_library(LIBMBEDCRYPTO_SHARED mbedcrypto)
find_library(LIBEV_SHARED ev)
find_library(LIBUDNS_SHARED cares)
find_library(LIBPCRE_SHARED pcre)

if (WITH_EMBEDDED_SRC)
list(APPEND DEPS_SHARED
        m
        bloom-shared
        cork-shared
        ipset-shared
        ${LIBEV_SHARED}
        ${LIBUDNS_SHARED}
        ${LIBPCRE_SHARED}
        ${LIBSODIUM_SHARED}
        ${LIBMBEDTLS_SHARED}
        ${LIBMBEDCRYPTO_SHARED}
        )
else ()
find_library(LIBBLOOM_SHARED bloom)
find_library(LIBCORK_SHARED cork)
find_library(LIBCORKIPSET_SHARED corkipset)
list(APPEND DEPS_SHARED
        m
        ${LIBBLOOM_SHARED}
        ${LIBCORK_SHARED}
        ${LIBCORKIPSET_SHARED}
        ${LIBEV_SHARED}
        ${LIBUDNS_SHARED}
        ${LIBPCRE_SHARED}
        ${LIBSODIUM_SHARED}
        ${LIBMBEDTLS_SHARED}
        ${LIBMBEDCRYPTO_SHARED}
        )
endif ()

find_package (Threads)

if (WITH_STATIC)
# ------------------------------------------------------------------
# Static
# By default we use normal name for static, all shared targets will add a `-shared' suffix
add_executable(ss-server ${SS_SERVER_SOURCE})
add_executable(ss-tunnel ${SS_TUNNEL_SOURCE})
if (WITH_SS_MANAGER)
    add_executable(ss-manager ${SS_MANAGER_SOURCE})
else ()
    add_executable(ss-manager EXCLUDE_FROM_ALL ${SS_MANAGER_SOURCE})
endif ()
add_executable(ss-local ${SS_LOCAL_SOURCE})
if (WITH_SS_REDIR)
    add_executable(ss-redir ${SS_REDIR_SOURCE})
else ()
    add_executable(ss-redir EXCLUDE_FROM_ALL ${SS_REDIR_SOURCE})
endif ()
add_library(shadowsocks-libev STATIC ${LIBSHADOWSOCKS_LIBEV_SOURCE})


target_compile_definitions(ss-server PUBLIC -DMODULE_REMOTE)
target_compile_definitions(ss-tunnel PUBLIC -DMODULE_TUNNEL)
target_compile_definitions(ss-manager PUBLIC -DMODULE_MANAGER)
target_compile_definitions(ss-local PUBLIC -DMODULE_LOCAL)
target_compile_definitions(ss-redir PUBLIC -DMODULE_REDIR)
target_compile_definitions(shadowsocks-libev PUBLIC -DMODULE_LOCAL -DLIB_ONLY)

target_include_directories(shadowsocks-libev PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(ss-server cork ipset ${DEPS})
target_link_libraries(ss-tunnel cork ${DEPS})
target_link_libraries(ss-manager m bloom cork ${LIBEV} ${LIBUDNS})
target_link_libraries(ss-local cork ipset ${DEPS})
target_link_libraries(ss-redir cork ipset ${DEPS})
target_link_libraries(shadowsocks-libev cork ipset ${DEPS})
endif ()

# ------------------------------------------------------------------
# Shared
# Shared target will have a `-shared' suffix
# All shared dependency also have `-shared' suffix
# For shared binary, we still use the same name as static, without `-shared', but will output to shared directory
add_executable(ss-server-shared ${SS_SERVER_SOURCE})
add_executable(ss-tunnel-shared ${SS_TUNNEL_SOURCE})
if (WITH_SS_MANAGER)
    add_executable(ss-manager-shared ${SS_MANAGER_SOURCE})
else ()
    add_executable(ss-manager-shared EXCLUDE_FROM_ALL ${SS_MANAGER_SOURCE})
endif ()
add_executable(ss-local-shared ${SS_LOCAL_SOURCE})
if (WITH_SS_REDIR)
    add_executable(ss-redir-shared ${SS_REDIR_SOURCE})
else ()
    add_executable(ss-redir-shared EXCLUDE_FROM_ALL ${SS_REDIR_SOURCE})
endif ()
add_library(shadowsocks-libev-shared SHARED ${LIBSHADOWSOCKS_LIBEV_SOURCE})

target_compile_definitions(ss-server-shared PUBLIC -DMODULE_REMOTE)
target_compile_definitions(ss-tunnel-shared PUBLIC -DMODULE_TUNNEL)
target_compile_definitions(ss-manager-shared PUBLIC -DMODULE_MANAGER)
target_compile_definitions(ss-local-shared PUBLIC -DMODULE_LOCAL)
target_compile_definitions(ss-redir-shared PUBLIC -DMODULE_REDIR)
target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL -DLIB_ONLY)

target_include_directories(shadowsocks-libev-shared PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(ss-server-shared ${DEPS_SHARED})
target_link_libraries(ss-tunnel-shared ${DEPS_SHARED})
target_link_libraries(ss-manager-shared ${CMAKE_THREAD_LIBS_INIT} ${LIBEV_SHARED} ${LIBUDNS_SHARED} ${DEPS_SHARED})
target_link_libraries(ss-local-shared ${DEPS_SHARED})
target_link_libraries(ss-redir-shared ${DEPS_SHARED})
target_link_libraries(shadowsocks-libev-shared ${DEPS_SHARED})

set_target_properties(ss-server-shared PROPERTIES OUTPUT_NAME ss-server)
set_target_properties(ss-tunnel-shared PROPERTIES OUTPUT_NAME ss-tunnel)
set_target_properties(ss-manager-shared PROPERTIES OUTPUT_NAME ss-manager)
set_target_properties(ss-local-shared PROPERTIES OUTPUT_NAME ss-local)
set_target_properties(ss-redir-shared PROPERTIES OUTPUT_NAME ss-redir)

set_target_properties(ss-server-shared ss-tunnel-shared ss-manager-shared ss-local-shared ss-redir-shared
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_SHARED_OUTPUT_DIRECTORY}
        )

set_target_properties(shadowsocks-libev-shared PROPERTIES OUTPUT_NAME shadowsocks-libev)
target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)
target_link_libraries(shadowsocks-libev-shared ${DEPS_SHARED})

# ------------------------------------------------------------------
# Misc
# Recommend to install shared by default
install(DIRECTORY ${RUNTIME_SHARED_OUTPUT_DIRECTORY}/
        USE_SOURCE_PERMISSIONS
        DESTINATION bin)

if (WITH_STATIC)
    install(TARGETS shadowsocks-libev
        ARCHIVE DESTINATION lib)
endif ()

install(TARGETS shadowsocks-libev-shared
        LIBRARY DESTINATION lib)

install(FILES shadowsocks.h DESTINATION include)


add_custom_target(distclean
        COMMAND ${CMAKE_COMMAND} -E echo WARNING: distclean target is not functional
        COMMAND ${CMAKE_COMMAND} -E echo Use 'git clean -fdx' instead
        VERBATIM
        )

=== docker/mingw/Makefile ===
#
# Makefile for building MinGW port
#
# This file is part of the shadowsocks-libev.
#
# shadowsocks-libev is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# shadowsocks-libev is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with shadowsocks-libev; see the file COPYING. If not, see
# <http://www.gnu.org/licenses/>.
#

REPO=shadowsocks
REV=master
IMAGE=ss-build-mingw
DIST=ss-libev-win-dist.tar.gz

all: build

build:
	cd ../../ && docker build -t $(IMAGE) \
	  -f docker/mingw/Dockerfile \
	  --build-arg REV=$(REV) --build-arg REPO=$(REPO) \
	  --build-arg REBUILD="$$(date +%Y-%m-%d-%H-%M-%S)" \
	  .
	docker run --rm --entrypoint cat $(IMAGE) /bin.tgz > $(DIST)

clean:
	rm -f $(DIST)
	docker rmi $(IMAGE) || true

.PHONY: all clean build

=== debian/changelog ===
shadowsocks-libev (3.3.5+ds-16) unstable; urgency=medium

  * Team upload.
  * debian/control: Remove myself from the package uploaders list.

 -- Boyuan Yang <byang@debian.org>  Sun, 02 Mar 2025 22:07:16 -0500

shadowsocks-libev (3.3.5+ds-15) unstable; urgency=medium

  * symbols: update to fix build on hurd-amd64

 -- Aron Xu <aron@debian.org>  Tue, 18 Feb 2025 01:44:10 +0800

shadowsocks-libev (3.3.5+ds-14) unstable; urgency=medium

  * d/control: update to new salsa address
  * Revert "d/patches: update mbedtls3.6 patch to upstream version"

 -- Aron Xu <aron@debian.org>  Mon, 17 Feb 2025 18:01:15 +0800

shadowsocks-libev (3.3.5+ds-13) unstable; urgency=medium

  * d/patches: update mbedtls3.6 patch to upstream version
  * Add patch to avoid ephemeral port exhaustion
  * symbols: updated

 -- Aron Xu <aron@debian.org>  Sat, 15 Feb 2025 00:12:48 +0800

shadowsocks-libev (3.3.5+ds-12) unstable; urgency=medium

  * Non-maintainer upload to fix autopkgtest issues.
  * tests: disable rc4/md5 test which is disabled through weak ciphers
  * tests: move dnsutils to bind9-dnsutils

 -- Aron Xu <aron@debian.org>  Tue, 11 Feb 2025 16:40:53 +0800

shadowsocks-libev (3.3.5+ds-11) unstable; urgency=medium

  * Re-introduce shadowsocks-libev
  * d/patches: add patch to upgrade to pcre2 (closes: #999965)
  * d/patches: add patch to fix build with mbedtls 3+
  * d/patches: add Forwarded header to all patches
  * d/control: update std-ver to 4.7.0 (no changes required)
  * d/control: update obsolete B-D items
  * Move systemd units from /lib to /usr/lib for usr-merge in trixie
    (closes: #1073774)
  * Remove scripts dir (useless for end-users) from ss-libev.docs
    (closes: #972748)

 -- Shengqi Chen <harry-chen@outlook.com>  Tue, 08 Oct 2024 23:26:37 +0800

shadowsocks-libev (3.3.5+ds-10) unstable; urgency=medium

  * Revert the move of systemd service files from /lib/ to /usr/lib/.
    Still place systemd service files under /lib/systemd/system/.
    (Closes: #1034220)

 -- Boyuan Yang <byang@debian.org>  Fri, 14 Apr 2023 20:46:30 -0400

shadowsocks-libev (3.3.5+ds-9) unstable; urgency=medium

  [ Gioele Barabucci ]
  * d/shadowsocks-libev.postinst: Generate random password with tr
    instead of perl.

  [ Roger Shimizu ]
  * debian/patches: Backport patches from upstream to fix issues
    - [1630764] Fix --mptcp on 5.6+ kernels with IPPROTO_MPTCP rather
                than setsockopt.
    - [01dd7df] Redir UDP send back sockets should always be IPv6.
    - [d61d09a] Detect kernel support for MPTCP at runtime.
  * debian/symbols: Update symbol file by backported upstream patches.

 -- Roger Shimizu <rosh@debian.org>  Sun, 29 Jan 2023 01:48:28 -0800

shadowsocks-libev (3.3.5+ds-8) unstable; urgency=medium

  * debian/patches: Backport trunk fixes till 2022-04-11.

 -- Roger Shimizu <rosh@debian.org>  Sun, 22 May 2022 00:26:42 +0900

shadowsocks-libev (3.3.5+ds-7) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on libcork-dev and libsodium-dev.
    + shadowsocks-libev: Drop versioned constraint on lsb-base in Depends.

  [ Roger Shimizu ]
  * debian/patches: Backport trunk fixes till 2021-08-19.

 -- Roger Shimizu <rosh@debian.org>  Thu, 20 Jan 2022 02:14:11 +0900

shadowsocks-libev (3.3.5+ds-6) unstable; urgency=medium

  * debian/shadowsocks-libev.install: Install systemd system service
    files directly into /usr/lib/systemd/, not /lib/system/system/.

 -- Boyuan Yang <byang@debian.org>  Wed, 08 Sep 2021 12:42:44 -0400

shadowsocks-libev (3.3.5+ds-5) unstable; urgency=medium

  * Rebuild after Debian 11 release.
    + Place systemd system services in /usr/lib/systemd/system/.

  [ Debian Janitor ]
  * Remove constraints unnecessary since stretch:
    + libshadowsocks-libev-dev: Drop versioned constraint on shadowsocks-libev
      in Breaks.
    + libshadowsocks-libev2: Drop versioned constraint on shadowsocks-libev in
      Breaks.
    + shadowsocks-libev: Drop versioned constraint on shadowsocks in Replaces.
    + shadowsocks-libev: Drop versioned constraint on shadowsocks in Breaks.

  [ Boyuan Yang ]
  * debian/salsa-ci.yml: Rename from gitlab-ci.yml.
  * Refresh packaging:
    + Bump to debhelper compat v13.
    + Bump to Standards-Version 4.6.0.
  * debian/*.service: Add Wants=network-online.target to ensure usable
    network before service starts. (upstream PR#2805)
  * debian/patches: Backport trunk fixes till 2021-03-16.
  * debian/patches/90: Add patch to use new location of libcorkipset
    headers to avoid build errors.

 -- Boyuan Yang <byang@debian.org>  Wed, 08 Sep 2021 12:17:39 -0400

shadowsocks-libev (3.3.5+ds-4) unstable; urgency=medium

  * debian/patches:
    - Update patch 04 to fix ftbfs for Hurd, again.

 -- Roger Shimizu <rosh@debian.org>  Tue, 22 Dec 2020 02:23:25 +0900

shadowsocks-libev (3.3.5+ds-3) unstable; urgency=medium

  * debian/patches:
    - Add patch 04 to fix ftbfs for Hurd since there is no IPV6_TCLASS
      defined.

 -- Roger Shimizu <rosh@debian.org>  Sat, 19 Dec 2020 23:51:08 +0900

shadowsocks-libev (3.3.5+ds-2) unstable; urgency=medium

  * debian/patches:
    - Backport from upstream to fix manager not passing -i option.

 -- Roger Shimizu <rosh@debian.org>  Thu, 17 Dec 2020 02:52:25 +0900

shadowsocks-libev (3.3.5+ds-1) unstable; urgency=medium

  * New upstream release: v3.3.5
  * debian/patches:
    - Refresh patches.
  * debian/copyright:
    - Remove src/json.*
    - Remove nonexisting entries: src/http.* src/protocol.h src/tls.*
  * Remove unused lintian-overrides.

 -- Roger Shimizu <rosh@debian.org>  Sat, 19 Sep 2020 18:00:05 +0900

shadowsocks-libev (3.3.4+ds-5) unstable; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata (already
    present in machine-readable debian/copyright).

  [ Roger Shimizu ]
  * d/maint-tools:


=== debian/control ===
Source: shadowsocks-libev
Section: net
Priority: optional
Maintainer: Debian Bridges Team <team+bridges@tracker.debian.org>
Uploaders:
 Max Lv <max.c.lv@gmail.com>,
 Roger Shimizu <rosh@debian.org>
Build-Depends:
 asciidoc-base | asciidoc,
 debhelper-compat (= 13),
 libbloom-dev,
 libc-ares-dev,
 libcork-dev,
 libcorkipset-dev,
 libev-dev,
 libjsonparser-dev,
 libmbedtls-dev,
 libpcre2-dev,
 libsodium-dev,
 pkgconf,
 xmlto,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.shadowsocks.org
Vcs-Git: https://salsa.debian.org/debian/shadowsocks-libev.git
Vcs-Browser: https://salsa.debian.org/debian/shadowsocks-libev

Package: libshadowsocks-libev-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libshadowsocks-libev2 (= ${binary:Version}),
 ${misc:Depends},
Description: lightweight and secure socks5 proxy (development files)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsocks (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides C header files for the libraries.

Package: libshadowsocks-libev2
Architecture: any
Multi-Arch: same
Section: libs
Replaces:
 libshadowsocks-libev1,
Breaks:
 libshadowsocks-libev1
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: lightweight and secure socks5 proxy (shared library)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsocks (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides shared libraries.

Package: shadowsocks-libev
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libcap2-bin [linux-any],
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 haveged,
 kcptun,
 simple-obfs,
Description: lightweight and secure socks5 proxy
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsocks (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND = -fPIC
export DEB_LDFLAGS_MAINT_APPEND = -fPIC

# Dummy folder for autotools scripts
LIBDIR=libbloom libcork libipset

override_dh_auto_clean:
	dh_auto_clean
	# dpkg-buildpackage complains these files from previous built
	find -name Makefile -exec rm {} \;
	rm -f config.h config.log config.status libtool shadowsocks-libev.pc stamp-h1

override_dh_autoreconf:
	# dh_auto_clean and dh_autoreconf complains if there're no these folders
	# they're removed after dh_autoreconf
	for libdir in ${LIBDIR}; do \
		mkdir -p $$libdir; \
		touch $$libdir/Makefile.in; \
	done
	dh_autoreconf
	rm -rf ${LIBDIR}

override_dh_auto_configure:
	# Whether to have stack-protector is decided by dpkg-buildflags.
	# So --disable-ssp here should be safe. See Bug#829498
	dh_auto_configure -- \
		--enable-shared \
		--enable-system-shared-lib \
		--disable-ssp

execute_before_dh_install:
	# remove libtool library
	rm -f debian/tmp/usr/lib/*/*.la

%:
	dh $@

=== debian/tests/control ===
Test-Command: bash tests/test.sh
Depends: @, python3, curl, bind9-dnsutils
Restrictions: allow-stderr
